/* EPITA - IP - S3/4 */
/* question04 */

#define QNUM 4
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question04.h"

static
void fixed_tests(void) {
  printf("Fixed tests:\n");
  size_t n = 1;
  for (unsigned long i = 0; i < 6; i++) {
    printf("digit_count(%zu) =\t%zu\n", n, digit_count(n));
    n *= 10;
  }
}

static
void random_test(size_t len) {
  printf("Random tests:\n");
  for (size_t i = 0; i < len; i++) {
    size_t n = random() >>  (5 + random() % 11);
    printf("digit_count(%zu) =\t%zu\n", n, digit_count(n));
  }
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_tests();
      random_test(size);
    }
  exit(0);
}
