/* EPITA - IP - S3/4 */
/* question10 */

#define QNUM 10
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question10.h"


static
void randsorted_fill(int *begin, int *end) {
  int last = random() % 10;
  for (;begin < end; begin++)
    *begin = (last += 1 + random() % 20);
}

static
void alt_fill(int *begin, int *end) {
  int *mid = begin + (end - begin + 1) / 2;
  for (int i = 0; begin < mid; begin++, i++)
    *begin = 2 * i + 1;
  for (int i = 1; begin < end; begin++, i++)
    *begin = 2 * i;
}

static
void lin_fill(int *begin, int *end) {
  for (int i = 1; begin < end; i++, begin++)
    *begin = i;
}

static
void print_array(int *begin, int *end) {
  for (; begin < end; begin++) {
    printf("| %3d ", *begin);
  }
  printf("|\n");
}

static
void fixed_test(size_t len) {
  printf("Fixed tests:\n");
  int *tab = malloc(len * sizeof (int));
  int *dst = calloc(len, sizeof (int));
  lin_fill(tab, tab + len);
  printf("  array1:\n    ");
  print_array(tab, tab + len / 2);
  printf("  array2:\n    ");
  print_array(tab + len / 2, tab + len);

  printf("  array_merge(dst, array1, array2, ...)\n");
  array_merge(dst, tab, tab + len / 2, tab + len / 2, tab + len);

  printf("  dst:\n    ");
  print_array(dst, dst + len);

  free(dst);
  free(tab);
}

static
void fixed_test2(size_t len) {
  printf("\nFixed tests (2):\n");
  int *tab = malloc(len * sizeof (int));
  int *dst = calloc(len, sizeof (int));
  int *mid = tab + (len + 1) / 2;
  alt_fill(tab, tab + len);
  printf("  array1:\n    ");
  print_array(tab, mid);
  printf("  array2:\n    ");
  print_array(mid, tab + len);

  printf("  array_merge(dst, array1, array2, ...)\n");
  array_merge(dst, tab, mid, mid, tab + len);

  printf("  dst:\n    ");
  print_array(dst, dst + len);

  free(dst);
  free(tab);
}

static
void random_test(size_t len) {
  printf("\nRandom tests:\n");
  int *a1 = malloc(len / 2 * sizeof (int));
  int *a2 = malloc((len + 1) / 2 * sizeof (int));
  int *e1 = a1 + len / 2;
  int *e2 = a2 + (len + 1) / 2;
  randsorted_fill(a1, e1);
  randsorted_fill(a2, e2);
  printf("  array1:\n    ");
  print_array(a1, a1 + len / 2);
  printf("  array2:\n    ");
  print_array(a2, e2);

  int *dst = calloc(len, sizeof (int));
  printf("  array_merge(dst, array1, array2, ...)\n");
  array_merge(dst, a1, a2, e1, e2);

  printf("  dst:\n    ");
  print_array(dst, dst + len);

  free(a1);
  free(a2);
  free(dst);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_test(size);
      fixed_test2(size);
      random_test(size);
    }
  exit(0);
}
