/* EPITA - IP - S3/4 */
/* question13 */

#define QNUM 13
#define QOPT "graine taille"
#define QNOPT 2

# include <assert.h>
# include <stdio.h>
# include <stdlib.h>
# include <unistd.h>

# include "base_test.h"
# include "question13.h"

static
void random_fill(long *begin, long *end) {
  for (; begin < end; begin++)
    *begin = random() % 20;
}

# if 0
static
void lin_fill(long *begin, long *end) {
  for (long i = 1; begin < end; i++, begin++)
    *begin = i;
}
# endif

static
void print_array(long *begin, long *end) {
  for (; begin < end; begin++) {
    printf("| %3ld ", *begin);
  }
  printf("|\n");
}

static
void unit_vector(long *begin, long *end, size_t unit)
{
  for (long *i = begin; i < end; ++i)
    *i = 0;
  begin[unit] = 1;
}

static
void all_one(long *begin, long *end)
{
  for (; begin < end; ++begin)
    *begin = 1;
}

static
void fixed_test(size_t len) {
  printf("Fixed tests:\n");
  long *a = calloc(len, sizeof (long));
  long *b = calloc(len, sizeof (long));
  random_fill(a, a + len);

  printf("  a:\n    ");
  print_array(a, a + len);

  all_one(b, b + len);
  printf("  b:\n    ");
  print_array(b, b + len);

  printf("dot_product(a,b) = %ld\n", dot_product(a, b, len));

  printf("\n");

  for (size_t i = 0; i < len; ++i) {
    unit_vector(b, b + len, i);
    printf("  b:\n    ");
    print_array(b, b + len);

    printf("dot_product(a,b) = %ld\n", dot_product(a, b, len));

    printf("\n");
  }

  free(a);
  free(b);
}


static
void random_test(size_t len) {
  printf("Random tests:\n");
  long *a = calloc(len, sizeof (long));
  long *b = calloc(len, sizeof (long));
  random_fill(a, a + len);
  random_fill(b, b + len);

  printf("  a:\n    ");
  print_array(a, a + len);
  printf("  b:\n    ");
  print_array(b, b + len);

  printf("dot_product(a,b) = %ld\n", dot_product(a, b, len));

  free(a);
  free(b);
}

int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_test(size);
      random_test(size);
    }
  exit(0);
}
